﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.Common;
using System.Data.OleDb;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace GroupSelection
{
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            #region "Populate the grid"

            DataTable _employees = new DataTable();
            String queryString = string.Empty;
            DbProviderFactory provider = DbProviderFactories.GetFactory("System.Data.OleDb");
            OleDbConnection conn = (OleDbConnection)provider.CreateConnection();
            string datasource = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments)
                                                   + "\\ComponentOne Samples\\Common\\C1NWind.mdb";
            conn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + datasource;
            DbCommand cmd = provider.CreateCommand();
            cmd.Connection = conn;
            conn.Open();
            DbDataAdapter da = provider.CreateDataAdapter();
            queryString = "SELECT * FROM Customers";
            cmd.CommandText = queryString;
            da.SelectCommand = cmd;
            da.Fill(_employees);
            this.c1TrueDBGrid1.DataSource = _employees;

            #endregion

            this.c1TrueDBGrid1.DataView = C1.Win.C1TrueDBGrid.DataViewEnum.GroupBy;

            // Add a Grouped Column
            this.c1TrueDBGrid1.GroupedColumns.Add(this.c1TrueDBGrid1.Columns["ContactTitle"]);
            this.c1TrueDBGrid1.GroupByAreaVisible = false;

            //Expand All Grouped Rows
            for (int i = 0; i < this.c1TrueDBGrid1.RowCount; i++)
            {
                if (this.c1TrueDBGrid1.Splits[0].Rows[i].RowType ==
                    C1.Win.C1TrueDBGrid.RowTypeEnum.CollapsedGroupRow)
                    this.c1TrueDBGrid1.ExpandGroupRow(i);
            }            
            this.c1TrueDBGrid1.MouseUp += new MouseEventHandler(c1TrueDBGrid1_MouseUp);                       
        }         

        void c1TrueDBGrid1_MouseUp(object sender, MouseEventArgs e)
        {   
            //Clear previous selections.
            this.c1TrueDBGrid1.SelectedRows.Clear();
            //Get the index of the display row.
            int displayrow_index = this.c1TrueDBGrid1.RowContaining(e.Y);
            
            //Exclude row headers
            if (displayrow_index != -1)
            {                
                var vr = this.c1TrueDBGrid1.Splits[0].Rows[displayrow_index];
                C1.Win.C1TrueDBGrid.GroupRow gr = vr as C1.Win.C1TrueDBGrid.GroupRow;
                
                //Verify GroupRow state and child nodes' visibility 
                    if (vr.RowType == C1.Win.C1TrueDBGrid.RowTypeEnum.ExpandedGroupRow
                        && this.c1TrueDBGrid1.Splits[0].Rows[gr.StartIndex].Visible)
                    {                        
                        for (int j = 1; j <= (gr.EndIndex - gr.StartIndex) + 1; j++)
                        {                     
                            c1TrueDBGrid1.SelectedRows.Add(displayrow_index + j);
                        }
                    }
                    else 
                    {
                        //don't select invisible child nodes
                        this.c1TrueDBGrid1.SelectedRows.Clear();
                    }
                    c1TrueDBGrid1.Refresh();
            }
        }
    }
}

